;file lib_initPorts.inc

lib_initPorts	macro
if RB_wked != RB_wked_PU
expand
			mov	m,#M_WKED	; point mode to WKED
			mov	!rb,#RB_wked
noexpand
endif
if RB_wken != RB_wken_PU
expand
			mov	m,#M_WKEN	; point mode to WKEN
			mov	!rb,#RB_wken
noexpand
endif
if RB_wkpnd != RB_wkpnd_PU
expand
			mov	m,#M_WKPND	 ;point mode to WKPND
			mov	w,#RB_WKPND
			mov	!rb,w
noexpand
endif
if RB_cmp != RB_cmp_PU
expand
			mov	m,#M_CMP	; point mode to CMP
			mov	w,#RB_cmp
			mov	!rb,w
noexpand
endif
if (RB_st != RB_st_PU) or (RC_st != RC_st_PU) or (RD_st != RD_st_PU) or (RE_st != RE_st_PU)
expand
			mov	m,#M_ST		; point mode to ST
noexpand
endif
if RE_st != RE_st_PU
  ifdef DEV_48
expand
			mov	!re,#RE_st
noexpand
  endif
endif
if RD_st != RD_st_PU
  ifdef DEV_48
expand
			mov	!rd,#RD_st
noexpand
  endif
endif
if RC_st != RC_st_PU
  ifndef DEV_18
expand
			mov	!rc,#RC_st
noexpand
  endif
endif
if RB_st != RB_st_PU
expand
			mov	!rb,#RB_st
noexpand
endif
if (RA_lvl != RA_lvl_PU) or (RB_lvl != RB_lvl_PU) or (RC_lvl != RC_lvl_PU) or (RD_lvl != RD_lvl_PU) or (RE_lvl != RE_lvl_PU)
expand
			mov	m,#M_LVL	; point mode to LVL
noexpand
endif
if RE_lvl != RE_lvl_PU
  ifdef DEV_48
expand
			mov	!re,#RE_lvl
noexpand
  endif
endif
if RD_lvl != RD_lvl_PU
  ifdef DEV_48
expand
			mov	!rd,#RD_lvl
noexpand
  endif
endif
if RC_lvl != RC_lvl_PU
  ifndef DEV_18
expand
			mov	!rc,#RC_lvl
noexpand
  endif
endif
if RB_lvl != RB_lvl_PU
expand
			mov	!rb,#RB_lvl
noexpand
endif
if RA_lvl != RA_lvl_PU
expand
			mov	!ra,#RA_lvl
noexpand
endif
if (RA_plp != RA_plp_PU) or (RB_plp != RB_plp_PU) or (RC_plp != RC_plp_PU) or (RD_plp != RD_plp_PU) or (RE_plp != RE_plp_PU)
expand
			mov	m,#M_PLP	; point mode to PLP
noexpand
endif
if RE_plp != RE_plp_PU
  ifdef DEV_48
expand
			mov	!re,#RC_plp
noexpand
  endif
endif
if RD_plp != RD_plp_PU
  ifdef DEV_48
expand
			mov	!rd,#RD_plp
noexpand
  endif
endif
if RC_plp != RC_plp_PU
  ifndef DEV_18
expand
			mov	!rc,#RC_plp
noexpand
  endif
endif
if RB_plp != RB_plp_PU
expand
			mov	!rb,#RB_plp
noexpand
endif
if RA_plp != RA_plp_PU
expand
			mov	!ra,#RA_plp
noexpand
endif
			;init latches
ifdef DEV_48
expand
			mov	re,#RE_tatch
			mov	rd,#RD_latch
noexpand
endif
ifndef DEV_18
expand
			mov	rc,#RC_latch
noexpand
endif
expand
			mov	rb,#RB_latch
			mov	ra,#RA_latch
noexpand
if (RA_tris != RA_tris_PU) or (RB_tris != RB_tris_PU) or (RC_tris != RC_tris_PU) or (RD_tris != RD_tris_PU) or (RE_tris != RE_tris_PU)
expand
			mov	m,#M_TRIS	; point mode to TRIS
noexpand
endif
expand
			mov	fsr,#$F0	;access direction register copies
			mov	w,#RE_tris
noexpand
if RE_tris != RE_tris_PU
  ifdef DEV_48
expand
			mov	!re,w
noexpand
  endif
endif
expand
			mov	portE_dirbuf,w
noexpand
if RD_tris != RE_tris
expand
			mov	w,#RD_tris
noexpand
endif
if RD_tris != RD_tris_PU
  ifdef DEV_48
expand
			mov	!rd,w
noexpand
  endif
endif
expand
			mov	portD_dirbuf,w
noexpand
if RC_tris != RD_tris
expand
			mov	w,#RC_tris
noexpand
endif
if RC_tris != RC_tris_PU
  ifndef DEV_18
expand
			mov	!rc,w
noexpand
  endif
endif
expand
			mov	portC_dirbuf,w
noexpand
if RB_tris != RC_tris
expand
			mov	w,#RB_tris
noexpand
endif
if RB_tris != RB_tris_PU
expand
			mov	!rb,w
noexpand
endif
expand
			mov	portB_dirbuf,w
noexpand
if RA_tris != RB_tris
expand
			mov	w,#RA_tris
noexpand
if RA_tris != RA_tris_PU
expand
			mov	!ra,w
noexpand
endif
expand
			mov	portA_dirbuf,w
noexpand
code		=	$
endm

;end of file lib_initPorts.inc
